Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -2468,49 +2613,57 @@ static Image *ReadOnePNGImage(MngInfo *m
         Image has a transparent background.
       */
       storage_class=image->storage_class;
-      image->matte=True;
+      image->matte=MagickTrue;
       for (y=0; y < (long) image->rows; y++)
         {
-          image->storage_class=storage_class;
           q=SetImagePixels(image,0,y,image->columns,1);
           if (q == (PixelPacket *) NULL)
             break;
           indexes=GetIndexes(image);
 
-          q->opacity=OpaqueOpacity;
           if (storage_class == PseudoClass)
             {
               IndexPacket
                 index;
 
-              if (ping_info->color_type == PNG_COLOR_TYPE_PALETTE)
+              if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
                 for (x=0; x < (long) image->columns; x++)
                   {
                     index=indexes[x];
-                    if (index < ping_info->num_trans)
+                    if (index < (unsigned int) ping_num_trans)
                       q->opacity=
-                        ScaleCharToQuantum(255-ping_info->trans[index]);
+                        ScaleCharToQuantum(255-ping_trans_alpha[index]);
+                    else
+                      q->opacity=OpaqueOpacity;
                     q++;
                   }
-              else if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+              else if (ping_colortype == PNG_COLOR_TYPE_GRAY)
                 for (x=0; x < (long) image->columns; x++)
                   {
                     index=indexes[x];
                     q->red=image->colormap[index].red;
                     q->green=image->colormap[index].green;
                     q->blue=image->colormap[index].blue;
-                    if (q->red == transparent_color.opacity)
+                    if ((unsigned long) ScaleQuantumToShort(q->red) ==
+                        transparent_color.opacity)
                       q->opacity=TransparentOpacity;
+                    else
+                      q->opacity=OpaqueOpacity;
                     q++;
                   }
             }
           else
             for (x=(long) image->columns; x > 0; x--)
               {
-                if (q->red == transparent_color.red &&
-                    q->green == transparent_color.green &&
-                    q->blue == transparent_color.blue)
+                if ((unsigned long) ScaleQuantumToShort(q->red) ==
+                    transparent_color.red &&
+                    (unsigned long) ScaleQuantumToShort(q->green) ==
+                    transparent_color.green &&
+                    (unsigned long) ScaleQuantumToShort(q->blue) ==
+                    transparent_color.blue)
                   q->opacity=TransparentOpacity;
+                else
+                  q->opacity=OpaqueOpacity;
                 q++;
               }
           if (!SyncImagePixels(image))
@@ -2530,19 +2683,23 @@ static Image *ReadOnePNGImage(MngInfo *m
         if (logging)
           (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                 "    Reading PNG text chunk");
-        if (!memcmp(text[i].key, "Raw profile type ",17))
-          (void) png_read_raw_profile(image,image_info,text,(int) i);
+        if (strlen(text[i].key) > 16 &&
+            !memcmp(text[i].key, "Raw profile type ",17))
+          {
+            if (png_read_raw_profile(image,image_info,text,(int) i) ==
+              MagickFail)
+            break;
+          }
         else
           {
             char
               *value;
 
-            length=text[i].text_length;
+            length=(unsigned long) text[i].text_length;
             value=MagickAllocateMemory(char *,length+1);
             if (value == (char *) NULL)
               {
-                (void) ThrowException3(&image->exception,ResourceLimitError,
-                                       MemoryAllocationFailed,UnableToReadTextChunk);
+                png_warning(ping, "Could not allocate memory for text chunk");
                 break;
               }
             *value='\0';
@@ -2577,11 +2734,9 @@ static Image *ReadOnePNGImage(MngInfo *m
           mng_info->ob[object_id]->frozen)
         {
           if (mng_info->ob[object_id] == (MngBuffer *) NULL)
-            (void) ThrowException(&image->exception,ResourceLimitError,
-                                  MemoryAllocationFailed,image->filename);
+            png_error(ping, "Could not allocate MNG object");
           if (mng_info->ob[object_id]->frozen)
-            (void) ThrowException(&image->exception,ResourceLimitError,
-                                  "Cannot overwrite frozen MNG object buffer",image->filename);
+            png_error(ping, "Could not overwrite MNG frozen object buffer");
         }
       else
         {
@@ -2597,14 +2752,16 @@ static Image *ReadOnePNGImage(MngInfo *m
             filter_method;
 
           if (mng_info->ob[object_id]->image != (Image *) NULL)
-            DestroyImage(mng_info->ob[object_id]->image);
-          mng_info->ob[object_id]->image=CloneImage(image,0,0,True,
+            {
+              DestroyImage(mng_info->ob[object_id]->image);
+              mng_info->ob[object_id]->image=(Image *) NULL;
+            }
+          mng_info->ob[object_id]->image=CloneImage(image,0,0,MagickTrue,
                                                     &image->exception);
           if (mng_info->ob[object_id]->image != (Image *) NULL)
             mng_info->ob[object_id]->image->file=(FILE *) NULL;
           else
-            (void) ThrowException(&image->exception,ResourceLimitError,
-                                  "Cloning image for object buffer failed",image->filename);
+            png_error(ping, "Cloning image for object buffer failed");
           png_get_IHDR(ping,ping_info,&width,&height,&bit_depth,&color_type,
                        &interlace_method,&compression_method,&filter_method);
           if (width > 250000L || height > 250000L)
@@ -2616,7 +2773,7 @@ static Image *ReadOnePNGImage(MngInfo *m
           mng_info->ob[object_id]->interlace_method=interlace_method;
           mng_info->ob[object_id]->compression_method=compression_method;
           mng_info->ob[object_id]->filter_method=filter_method;
-          if (ping_info->valid & PNG_INFO_PLTE)
+          if (png_get_valid(ping, ping_info, PNG_INFO_PLTE))
             {
               int
                 number_colors;
@@ -2643,8 +2800,9 @@ static Image *ReadOnePNGImage(MngInfo *m
     Free memory.
   */
   png_destroy_read_struct(&ping,&ping_info,&end_info);
+  MagickFreeMemory(mng_info->quantum_scanline);
+  MagickFreeMemory(mng_info->png_pixels);
 
-  MagickFreeMemory(png_pixels);
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
   LiberateSemaphoreInfo(&png_semaphore);
 #endif
@@ -2654,6 +2812,8 @@ static Image *ReadOnePNGImage(MngInfo *m
                           "  exit ReadOnePNGImage()");
   return (image);
 
+  /* End of setjmp-controlled block } */
+
   /* end of reading one PNG image */
 }
 
@@ -2661,8 +2821,7 @@ static Image *ReadPNGImage(const ImageIn
                            ExceptionInfo *exception)
 {
   Image
-    *image,
-    *previous;
+    *image;
 
   MngInfo
     *mng_info;
@@ -2688,27 +2847,41 @@ static Image *ReadPNGImage(const ImageIn
   image=AllocateImage(image_info);
   mng_info=(MngInfo *) NULL;
   status=OpenBlob(image_info,image,ReadBinaryBlobMode,exception);
-  if (status == False)
+  if (status == MagickFalse)
     ThrowReaderException(FileOpenError,UnableToOpenFile,image);
   /*
     Verify PNG signature.
   */
   (void) ReadBlob(image,8,magic_number);
   if (memcmp(magic_number,"\211PNG\r\n\032\n",8) != 0)
+  {
     ThrowReaderException(CorruptImageError,ImproperImageHeader,image);
+  }
+
+  /*
+     Verify that file size large enough to contain a PNG datastream
+     if using a seekable blob
+  */
+  if (BlobIsSeekable(image) && GetBlobSize(image) < 61)
+  {
+    ThrowReaderException(CorruptImageError,InsufficientImageDataInFile,image);
+  }
+
   /*
     Allocate a MngInfo structure.
   */
-  have_mng_structure=False;
+  have_mng_structure=MagickFalse;
   mng_info=MagickAllocateMemory(MngInfo *,sizeof(MngInfo));
   if (mng_info == (MngInfo *) NULL)
+  {
     ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
+  }
   /*
     Initialize members of the MngInfo structure.
   */
   (void) memset(mng_info,0,sizeof(MngInfo));
   mng_info->image=image;
-  have_mng_structure=True;
+  have_mng_structure=MagickTrue;
 
   image=ReadOnePNGImage(mng_info,image_info,exception);
   MngInfoFreeStruct(mng_info,&have_mng_structure);
@@ -2725,6 +2898,7 @@ static Image *ReadPNGImage(const ImageIn
       if (image->exception.severity > exception->severity)
         CopyException(exception,&image->exception);
       DestroyImageList(image);
+      image=(Image *) NULL;
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "exit ReadPNGImage() with error.");
@@ -2741,7 +2915,7 @@ static Image *ReadPNGImage(const ImageIn
   if (LocaleCompare(image_info->magick,"PNG24") == 0)
     {
       (void) SetImageType(image,TrueColorType);
-      image->matte=False;
+      image->matte=MagickFalse;
     }
   if (LocaleCompare(image_info->magick,"PNG32") == 0)
     (void) SetImageType(image,TrueColorMatteType);
@@ -2753,20 +2927,33 @@ static Image *ReadPNGImage(const ImageIn
 
 
 #if defined(JNG_SUPPORTED)
-void
-DestroyJNG(unsigned char *chunk,Image *color_image,ImageInfo *color_image_info,
-   Image *alpha_image,ImageInfo *alpha_image_info)
-{
-  if (chunk)
-    MagickFreeMemory(chunk);
-  if (color_image_info)
-    DestroyImageInfo(color_image_info);
-  if (alpha_image_info)
-    DestroyImageInfo(alpha_image_info);
-  if (color_image)
-    DestroyImage(color_image);
-  if (alpha_image)
-    DestroyImage(alpha_image);
+
+static void
+DestroyJNG(unsigned char *chunk,Image **color_image,
+   ImageInfo **color_image_info,
+   Image **alpha_image,ImageInfo **alpha_image_info)
+{
+  MagickFreeMemory(chunk);
+  if (*color_image_info)
+  {
+    DestroyImageInfo(*color_image_info);
+    *color_image_info = (ImageInfo *)NULL;
+  }
+  if (*alpha_image_info)
+  {
+    DestroyImageInfo(*alpha_image_info);
+    *alpha_image_info = (ImageInfo *)NULL;
+  }
+  if (*color_image)
+  {
+    DestroyImage(*color_image);
+    *color_image = (Image *)NULL;
+  }
+  if (*alpha_image)
+  {
+    DestroyImage(*alpha_image);
+    *alpha_image = (Image *)NULL;
+  }
 }
 /*
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -2821,13 +3008,10 @@ static Image *ReadOneJNGImage(MngInfo *m
   long
     y;
 
-  png_uint_32
+  unsigned long
     jng_height,
     jng_width;
 
-  magick_int64_t
-    pixels_resource;
-
   png_byte
     jng_color_type,
     jng_image_sample_depth,
@@ -2842,7 +3026,6 @@ static Image *ReadOneJNGImage(MngInfo *m
     *s;
 
   register long
-    i,
     x;
 
   register PixelPacket
@@ -2855,7 +3038,6 @@ static Image *ReadOneJNGImage(MngInfo *m
     logging,
     read_JSEP,
     reading_idat,
-    skip_to_iend,
     status;
 
   size_t
@@ -2894,11 +3076,8 @@ static Image *ReadOneJNGImage(MngInfo *m
     Signature bytes have already been read.
   */
 
-  read_JSEP=False;
-  reading_idat=False;
-  skip_to_iend=False;
-
-  pixels_resource = GetMagickResourceLimit(PixelsResource);
+  read_JSEP=MagickFalse;
+  reading_idat=MagickFalse;
 
   for (;;)
     {
@@ -2915,62 +3094,73 @@ static Image *ReadOneJNGImage(MngInfo *m
         Read a new JNG chunk.
       */
 
-      if (!MagickMonitor(LoadImagesTag,TellBlob(image),2*GetBlobSize(image),
-                         exception))
-        break;
+      if (!MagickMonitor(LoadImagesTag,TellBlob(image),2*GetBlobSize(image),exception))
+          break;
 
       type[0]='\0';
       (void) strcat(type,"errr");
-      length=(size_t)ReadBlobMSBLong(image);
-      count=ReadBlob(image,4,type);
+      length=(size_t) ReadBlobMSBLong(image);
+      count=(unsigned int) ReadBlob(image,4,type);
 
       if (logging)
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "  Reading JNG chunk type %c%c%c%c, length: %lu",
-                              type[0],type[1],type[2],type[3],length);
+        {
+          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                " Reading JNG chunk type %c%c%c%c, "
+                                "length: %lu",
+                                type[0],type[1],type[2],type[3],
+                                length);
+
+          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                "   count=%u",count);
+        }
 
       if (length > PNG_MAX_UINT || count == 0)
-      {
-        DestroyJNG(NULL,color_image,color_image_info,
-                   alpha_image,alpha_image_info);
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "chunk length (%lu) > PNG_MAX_UINT",length);
-        return ((Image*)NULL);
-      }
+        {
+          DestroyJNG(NULL,&color_image,&color_image_info,
+            &alpha_image,&alpha_image_info);
+          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "chunk length (%lu) > PNG_MAX_UINT",
+                                length);
+          ThrowException(exception,CorruptImageError,
+                         ImproperImageHeader,image->filename);
+          return ((Image*)NULL);
+        }
+
       chunk=(unsigned char *) NULL;
       p=NULL;
       if (length)
         {
           chunk=MagickAllocateMemory(unsigned char *,length);
           if (chunk == (unsigned char *) NULL)
-          {
-            DestroyJNG(chunk,color_image,color_image_info,
-                       alpha_image,alpha_image_info);
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    Could not allocate chunk memory");
-            return ((Image*)NULL);
-          }
-          for (i=0; i < (long) length; i++)
-            chunk[i]=ReadBlobByte(image);
+            {
+              DestroyJNG(chunk,&color_image,&color_image_info,
+                &alpha_image,&alpha_image_info);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                  "    Could not allocate chunk memory");
+              ThrowException(exception,ResourceLimitError,
+                             MemoryAllocationFailed,image->filename);
+              return ((Image*)NULL);
+            }
+          if (ReadBlob(image,length,chunk) < length)
+            {
+              DestroyJNG(chunk,&color_image,&color_image_info,
+                &alpha_image,&alpha_image_info);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                  "    chunk reading was incomplete");
+              ThrowException(exception,CorruptImageError,
+                             InsufficientImageDataInFile,image->filename);
+              return ((Image*)NULL);
+            }
           p=chunk;
         }
       (void) ReadBlobMSBLong(image);  /* read crc word */
 
-      if (skip_to_iend)
-        {
-          if (length)
-            MagickFreeMemory(chunk);
-          continue;
-        }
-
       if (!memcmp(type,mng_JHDR,4))
         {
           if (length == 16)
             {
-              jng_width=(unsigned long) ((p[0] << 24) | (p[1] << 16) |
-                                         (p[2] << 8) | p[3]);
-              jng_height=(unsigned long) ((p[4] << 24) | (p[5] << 16) |
-                                          (p[6] << 8) | p[7]);
+              jng_width=(unsigned long) mng_get_long(p);
+              jng_height=(unsigned long) mng_get_long(&p[4]);
               jng_color_type=p[8];
               jng_image_sample_depth=p[9];
               jng_image_compression_method=p[10];
@@ -2982,39 +3172,51 @@ static Image *ReadOneJNGImage(MngInfo *m
               if (logging)
                 {
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_width:      %16lu",jng_width);
+                      "    jng_width:      %16lu",
+                      jng_width);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_width:      %16lu",jng_height);
+                      "    jng_height:     %16lu",
+                      jng_height);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_color_type: %16d",jng_color_type);
+                      "    jng_color_type: %16d",
+                      jng_color_type);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_image_sample_depth:      %3d",
-                                        jng_image_sample_depth);
+                      "    jng_image_sample_depth:      %3d",
+                      jng_image_sample_depth);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_image_compression_method:%3d",
-                                        jng_image_compression_method);
+                      "    jng_image_compression_method:%3d",
+                      jng_image_compression_method);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_image_interlace_method:  %3d",
-                                        jng_image_interlace_method);
+                      "    jng_image_interlace_method:  %3d",
+                      jng_image_interlace_method);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_alpha_sample_depth:      %3d",
-                                        jng_alpha_sample_depth);
+                      "    jng_alpha_sample_depth:      %3d",
+                      jng_alpha_sample_depth);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_alpha_compression_method:%3d",
-                                        jng_alpha_compression_method);
+                      "    jng_alpha_compression_method:%3d",
+                      jng_alpha_compression_method);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_alpha_filter_method:     %3d",
-                                        jng_alpha_filter_method);
+                      "    jng_alpha_filter_method:     %3d",
+                      jng_alpha_filter_method);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    jng_alpha_interlace_method:  %3d",
-                                        jng_alpha_interlace_method);
+                      "    jng_alpha_interlace_method:  %3d",
+                      jng_alpha_interlace_method);
                 }
             }
-          if (length)
-            MagickFreeMemory(chunk);
 
+          MagickFreeMemory(chunk);
 
-          SetMagickResourceLimit(PixelsResource,jng_width*jng_height);
+          if (jng_width > 65535 || jng_height > 65535)
+            {
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                 "    JNG width or height too large: (%lu x %lu)",
+                  jng_width, jng_height);
+              ThrowException(exception,CorruptImageError,
+                             ImproperImageHeader,image->filename);
+              DestroyJNG(chunk,&color_image,&color_image_info,
+                &alpha_image,&alpha_image_info);
+              return ((Image *)NULL);
+            }
 
           /* Rationalize dimensions with blob size if it is available */
           if (BlobIsSeekable(image))
@@ -3026,10 +3228,16 @@ static Image *ReadOneJNGImage(MngInfo *m
               if ((blob_size == 0) ||
                   ((((double) jng_width*jng_height)/blob_size) > 512.0))
                 {
+                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                        "    Unreasonable dimensions: "
+                                        "geometry = %lux%lu, "
+                                        "blob size = %ld",
+                                        jng_width, jng_height, blob_size);
+
                   ThrowException(exception,CorruptImageError,
                                  InsufficientImageDataInFile,image->filename);
-                  DestroyJNG(chunk,color_image,color_image_info,
-                             alpha_image,alpha_image_info);
+                  DestroyJNG(chunk,&color_image,&color_image_info,
+                             &alpha_image,&alpha_image_info);
                   return ((Image *)NULL);
                 }
             }
@@ -3037,11 +3245,9 @@ static Image *ReadOneJNGImage(MngInfo *m
           continue;
         }
 
-
-      if (!reading_idat && !read_JSEP && (!memcmp(type,mng_JDAT,4) ||
-                                          !memcmp(type,mng_JdAA,4) ||
-                                          !memcmp(type,mng_IDAT,4) ||
-                                          !memcmp(type,mng_JDAA,4)))
+      if ((reading_idat == MagickFalse) && (read_JSEP == MagickFalse) &&
+         ((memcmp(type,mng_JDAT,4) == 0) || (memcmp(type,mng_JdAA,4) == 0) ||
+         (memcmp(type,mng_IDAT,4) == 0) || (memcmp(type,mng_JDAA,4) == 0)))
         {
           /*
             o create color_image
@@ -3052,58 +3258,66 @@ static Image *ReadOneJNGImage(MngInfo *m
 
           color_image_info=MagickAllocateMemory(ImageInfo *,sizeof(ImageInfo));
           if (color_image_info == (ImageInfo *) NULL)
-          {
-            DestroyJNG(chunk,color_image,color_image_info,
-                       alpha_image,alpha_image_info);
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    could not allocate color_image_info");
-            return ((Image *)NULL);
-          }
+            {
+              DestroyJNG(chunk,&color_image,&color_image_info,
+                &alpha_image,&alpha_image_info);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                  "    could not allocate color_image_info");
+              ThrowException(exception,ResourceLimitError,
+                             MemoryAllocationFailed,image->filename);
+              return ((Image *)NULL);
+            }
           GetImageInfo(color_image_info);
           color_image=AllocateImage(color_image_info);
           if (color_image == (Image *) NULL)
-          {
-            DestroyJNG(chunk,color_image,color_image_info,
-                       alpha_image,alpha_image_info);
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    could not allocate color_image");
-            return ((Image *)NULL);
-          }
+            {
+              DestroyJNG(chunk,&color_image,&color_image_info,
+                &alpha_image,&alpha_image_info);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                  "    could not allocate color_image");
+              ThrowException(exception,ResourceLimitError,
+                             MemoryAllocationFailed,image->filename);
+              return ((Image *)NULL);
+            }
           if (logging)
             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                   "    Creating color_blob.");
           (void) AcquireUniqueFilename(color_image->filename);
           status=OpenBlob(color_image_info,color_image,WriteBinaryBlobMode,
                           exception);
-          if (status == False)
-          {
-            DestroyJNG(chunk,color_image,color_image_info,
-                       alpha_image,alpha_image_info);
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    could not open alpha_image blob");
-            return ((Image *)NULL);
-          }
+          if (status == MagickFalse)
+            {
+              DestroyJNG(chunk,&color_image,&color_image_info,
+                &alpha_image,&alpha_image_info);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                  "    could not open color_image blob");
+              return ((Image *)NULL);
+            }
 
           if (!image_info->ping && jng_color_type >= 12)
             {
               alpha_image_info=MagickAllocateMemory(ImageInfo *,
                                                     sizeof(ImageInfo));
               if (alpha_image_info == (ImageInfo *) NULL)
-              {
-                DestroyJNG(chunk,color_image,color_image_info,
-                           alpha_image,alpha_image_info);
-                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                      "    could not allocate alpha_image_alpha");
-                return ((Image *)NULL);
-              }
+                {
+                  DestroyJNG(chunk,&color_image,&color_image_info,
+                    &alpha_image,&alpha_image_info);
+                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                      "    could not allocate alpha_image_info");
+                  ThrowException(exception,ResourceLimitError,
+                                 MemoryAllocationFailed,image->filename);
+                  return ((Image *)NULL);
+                }
               GetImageInfo(alpha_image_info);
               alpha_image=AllocateImage(alpha_image_info);
               if (alpha_image == (Image *) NULL)
                 {
-                  DestroyJNG(chunk,color_image,color_image_info,
-                             alpha_image,alpha_image_info);
+                  DestroyJNG(chunk,&color_image,&color_image_info,
+                    &alpha_image,&alpha_image_info);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "    could not allocate alpha_image");
+                      "    could not allocate alpha_image");
+                  ThrowException(exception,ResourceLimitError,
+                                 MemoryAllocationFailed,image->filename);
                   return ((Image *)NULL);
                 }
               if (logging)
@@ -3112,13 +3326,14 @@ static Image *ReadOneJNGImage(MngInfo *m
               (void) AcquireUniqueFilename(alpha_image->filename);
               status=OpenBlob(alpha_image_info,alpha_image,WriteBinaryBlobMode,
                               exception);
-              if (status == False)
-              {
-                DestroyJNG(chunk,color_image,color_image_info,
-                           alpha_image,alpha_image_info);
-                DestroyImage(alpha_image);
-                return ((Image *)NULL);
-              }
+              if (status == MagickFalse)
+                {
+                  DestroyJNG(chunk,&color_image,&color_image_info,
+                    &alpha_image,&alpha_image_info);
+                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                      "    could not open alpha_image blob");
+                  return ((Image *)NULL);
+                }
               if (jng_alpha_compression_method == 0)
                 {
                   unsigned char
@@ -3126,7 +3341,8 @@ static Image *ReadOneJNGImage(MngInfo *m
 
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                          "    Writing IHDR chunk to alpha_blob.");
+                                          "    Writing IHDR chunk"
+                                          " to alpha_blob.");
                   (void) WriteBlob(alpha_image,8,"\211PNG\r\n\032\n");
                   (void) WriteBlobMSBULong(alpha_image,13L);
                   PNGType(data,mng_IHDR);
@@ -3142,7 +3358,7 @@ static Image *ReadOneJNGImage(MngInfo *m
                   (void) WriteBlobMSBULong(alpha_image,crc32(0,data,17));
                 }
             }
-          reading_idat=True;
+          reading_idat=MagickTrue;
         }
 
       if (!memcmp(type,mng_JDAT,4))
@@ -3153,11 +3369,13 @@ static Image *ReadOneJNGImage(MngInfo *m
 
           if (logging)
             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    Copying JDAT chunk data to color_blob.");
-
-          if (length) {
-            if (color_image != (Image *)NULL)
-              (void) WriteBlob(color_image,length,(char *) chunk);
+                                  "    Copying %l"
+                                  "u bytes of JDAT chunk data"
+                                  " to color_blob.",
+                                  length);
+          if (length && color_image != (Image *)NULL)
+          {
+            (void) WriteBlob(color_image,length,(char *) chunk);
             MagickFreeMemory(chunk);
           }
           continue;
@@ -3172,22 +3390,31 @@ static Image *ReadOneJNGImage(MngInfo *m
             Copy IDAT header and chunk data to alpha_image->blob
           */
 
-          if (!image_info->ping)
+          if (alpha_image != NULL && image_info->ping == MagickFalse)
             {
               if (logging)
+              {
                 (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                      "    Copying IDAT chunk data to alpha_blob.");
-
+                    "    Copying IDAT chunk data"
+                    " to alpha_blob.");
+              }
+              if (length == 0)
+              {
+                if (logging)
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                    "    IDAT chunk has length 0");
+                MagickFreeMemory(chunk);
+                continue;
+              }
               (void) WriteBlobMSBULong(alpha_image,(unsigned long) length);
               PNGType(data,mng_IDAT);
               LogPNGChunk(logging,mng_IDAT,length);
               (void) WriteBlob(alpha_image,4,(char *) data);
               (void) WriteBlob(alpha_image,length,(char *) chunk);
               (void) WriteBlobMSBULong(alpha_image,
-                                       crc32(crc32(0,data,4),chunk,length));
+                                       crc32(crc32(0,data,4),chunk,(uInt) length));
             }
-          if (length)
-            MagickFreeMemory(chunk);
+          MagickFreeMemory(chunk);
           continue;
         }
 
@@ -3197,24 +3424,23 @@ static Image *ReadOneJNGImage(MngInfo *m
             Copy chunk data to alpha_image->blob
           */
 
-          if (!image_info->ping)
+          if (alpha_image != NULL && image_info->ping == MagickFalse)
             {
               if (logging)
                 (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                      "    Copying JDAA chunk data to alpha_blob.");
+                                      "    Copying JDAA chunk data"
+                                      " to alpha_blob.");
 
               (void) WriteBlob(alpha_image,length,(char *) chunk);
             }
-          if (length)
-            MagickFreeMemory(chunk);
+          MagickFreeMemory(chunk);
           continue;
         }
 
       if (!memcmp(type,mng_JSEP,4))
         {
-          read_JSEP=True;
-          if (length)
-            MagickFreeMemory(chunk);
+          read_JSEP=MagickTrue;
+          MagickFreeMemory(chunk);
           continue;
         }
 
